/*
 * @(#)BoolWob.java
 *
 * Copyright 2007 Demicron, Inc. All rights reserved.
 *
 * This software is the proprietary information of Demicron, Inc.
 */
package wobs.bool.player;

import java.io.*;
import com.wirefusion.player.*;

/**
 * Represents a Boolean object in the WireFusion player.
 */
public class BoolWob extends Wob {

	/**
	 * Contains the boolean value
	 * @exclude
	 */
	public boolean _value;

	private boolean pushAtStartup = false;
	

	/**
	 * @exclude
	 */
	public BoolWob() {		
	}
	

	
	/**
	 * Returns the boolean value.
	 * 
	 * @return the boolean value
	 */
	public boolean getValue() {
		return _value;
	}
	
	/**
	 * Creates a BoolWob object.
	 * 
	 * @param value a boolean value
	 */
	public BoolWob(boolean value) {
		this._value = value;
	}
	
	/**
	 * @exclude
	 */
	public void _presentationStarted() {
		if (pushAtStartup)
			pushValue();
	}
	
	/**
	 * @exclude
	 */
	public String toString() {
		return "" + _value; 
	}

	/**
	 * Pushes the boolean value through the Value Pushed out-port
	 * @exclude
	 */	
	public void pushValue() {
		sendBoolean(_value, 1);
	}


/**
 * 
 */
	public void processInportEvent(Wob arg, int inport) {
		switch (inport) {
		case 1: // Set Value
			_value = ((BoolWob) arg)._value;
			return;
		case 2:
			pushValue();
			return;
		}
	}
	
	/**
	 * @exclude
	 */
	public void readData(DataInputStream dis) {
		try {
			_value = dis.readBoolean();
			pushAtStartup = dis.readBoolean();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}	
}