/*
 * @(#)NumberWob.java
 *
 * Copyright 2007 Demicron, Inc. All rights reserved.
 *
 * This software is the proprietary information of Demicron, Inc.
 */
package wobs.number.player;

import java.io.*;
import com.wirefusion.player.*;

/**
 * Represents a Number object in the WireFusion player.
 */

public class NumberWob extends Wob {
	/**
	 * Contains the number value
	 * @exclude
	 */
	public double _value;

	private boolean pushAtStartup = false;

	/**
	 * @exclude
	 */
	public NumberWob() {		
	}
	
	/**
	 * Creates a NumberWob object
	 * 
	 * @param value A double value
	 */
	public NumberWob(double value) {
		this._value = value;
	}
	
	/**
	 * Returns the color value (RGB).
	 * 
	 * @return the color value
	 */
	public double getValue() {
		return _value;
	}
	
	/**
	 * @exclude
	 */
	public void _presentationStarted() {
		if (pushAtStartup)
			pushValue();
	}
	
	/**
	 * @exclude
	 */
	public String toString() {
		return "" + _value;
	}
	
	/**
	 * Pushes the number value through the Value Pushed out-port
	 * @exclude
	 */
	private void pushValue() {
		sendNumber(_value, 1);
	}


/**
 * 
 */
	public void processInportEvent(Wob arg, int inport) {
		if (inport == 1) { // Set Value
			_value = (((NumberWob) arg)._value);
		} else if (inport == 2) { // Push Value
			pushValue();
		} else if (inport == 3) { // Set Value from Text
			try {
				_value = (new Double(((wobs.text.player.TextWob) arg)._value)).doubleValue();
			} catch (Exception e) {
			}
		}
	}
	
	/**
	 * @exclude
	 */
	public void readData(DataInputStream dis) {
		try {
			_value = dis.readDouble();
			pushAtStartup = dis.readBoolean();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}	
}