/*
 * @(#)Number2DWob.java
 *
 * Copyright 2007 Demicron, Inc. All rights reserved.
 *
 * This software is the proprietary information of Demicron, Inc.
 */
package wobs.number2d.player;

import java.io.*;
import wobs.number.player.*;
import com.wirefusion.player.*;

/**
 * Represents a Number2D object in the WireFusion player.
 */

public class Number2DWob extends Wob {
	/**
	 * Contains the first number value
	 * @exclude
	 */
	public double _x;

	/**
	 * Contains the second number value
	 * @exclude
	 */
	public double _y;

	private boolean setAtStartup = false;

	/**
	 * @exclude
	 */
	public Number2DWob() {		
	}
	
	/**
	 * Creates a Number2DWob object.
	 * 
	 * @param x the first double value
	 * @param y the second double value
	 */
	public Number2DWob(double x, double y) {	
		this._x = x;
		this._y = y;
	}
	
	/**
	 * Returns the "x" value.
	 * 
	 * @return the "x" value
	 */
	public double getValue1() {
		return _x;
	}
	
	/**
	 * Returns the "y" value.
	 * 
	 * @return the "y" value
	 */
	public double getValue2() {
		return _y;
	}
	
	/**
	 * @exclude
	 */
	public void _presentationStarted() {
		if (setAtStartup)
			sendNumber2D(_x, _y, 1);
	}
	
	/**
	 * @exclude
	 */
	public String toString() {
		return "[" + _x + "," + _y + "]";
	}


/**
 * 
 */
	public void processInportEvent(Wob arg, int inport) {
		switch (inport) { // Set NumberPair
		case 1:
			Number2DWob v = ((Number2DWob) arg);
			_x = v._x;
			_y = v._y;
			break;
		case 2:
			_x = ((NumberWob) arg)._value; // Set Number 1
			break;
		case 3:
			_y = ((NumberWob) arg)._value; // Set Number 2
			break;
		case 4:
			sendNumber2D(_x, _y, 1);
			break; // Push NumberPair
		case 5:
			sendNumber(_x, 2);
			break; // Push Number 1
		case 6:
			sendNumber(_y, 3);
			break; // Push Number 2
		}
	}
	
	/**
	 * @exclude
	 */
	public void readData(DataInputStream dis) {
		try {
			_x = dis.readDouble();
			_y = dis.readDouble();
			setAtStartup = dis.readBoolean();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

}