package wobs.text;

import java.io.*;


import com.wirefusion.project.*;


public class TextProperties extends WobProperties implements Externalizable {//, ActionListener {
    static final long serialVersionUID = 7939300311453139239L;

    private String text;
    private boolean pushAtStartup;

    public boolean isPushAtStartup() {
    	return pushAtStartup;
    }
    
    public void setPushAtStartup(boolean pushAtStartup) {
    	this.pushAtStartup = pushAtStartup;
    }
    
    public void writeExternal(ObjectOutput out) {
        try {
            ObjectOutputStream oos = (ObjectOutputStream)out;
            super.writeExternal(oos);
            oos.writeUTF(text);
            oos.writeBoolean(pushAtStartup);
        } catch (Exception e) {System.out.println("WriteTextDialog: "+e);} //$NON-NLS-1$
    }

    public void readExternal(ObjectInput in) {
        try {
            ObjectInputStream ois = (ObjectInputStream)in;
            super.readExternal(ois);
            text = ois.readUTF();
            if (Project.fileFormatVersion>=12) {
                pushAtStartup=ois.readBoolean();
            }
        } catch (Exception e) {System.out.println("ReadTextDialog: "+e);if (!e.getMessage().equals("progress")) e.printStackTrace();} //$NON-NLS-1$ //$NON-NLS-2$
    }



    public String toString() {
      return text;
    }

 /*   public void destroyGUI() {
        panel.removeAll();
        textArea = null;
        panel = null;
        startupBox=null;
    }*/

    public String getString() {
        return text;
    }

    public void setString(String text) {
      this.text = text;
    }    
    
    public TextProperties() {
        super(); // S? att parentBVis blir satt
      	//setWobPropertiesPanelClass(TextPropertiesPanel.class);
        text = Messages.getString("TextProperties.Example_Text"); //$NON-NLS-1$
    }

    // returnar false om det inte fanns n?n unicode-character
    private String replaceUnicodeChars(String s) {
        int index = 0;
        while ((index = s.indexOf("\\u", index))!=-1) { //$NON-NLS-1$
            try {
                int unicode = Integer.parseInt(s.substring(index+2, index+6), 16);
                String sNew = s.substring(0, index);
                sNew += (char)unicode;
                sNew += s.substring(index+6, s.length());
                s = sNew;
            } catch (Exception e) {index++;} // gick inte att k?ra parseint, dvs inte en unicode-character
        }
        return s;
    }

    public void writeData(DataOutputStream dos) {
        try {
            String finalText = replaceUnicodeChars(text.toString());
            dos.writeUTF(finalText);
            dos.writeBoolean(pushAtStartup);
        } catch (IOException e) {System.out.println(e);}
    }




}