/*
 * @(#)TextWob.java
 *
 * Copyright 2007 Demicron, Inc. All rights reserved.
 *
 * This software is the proprietary information of Demicron, Inc.
 */
package wobs.text.player;

import java.io.*;
import com.wirefusion.player.*;

/**
 * Represents a Text object in the WireFusion player.
 */

public class TextWob extends Wob {
	/**
	 * Contains the String value
	 * @exclude
	 */
	public String _value;

	private boolean pushAtStartup = false;
	
	/**
	 * @exclude
	 */
	public TextWob() {		
	}
	
	/**
	 * Creates a TextWob object.
	 * 
	 * @param value
	 */
	public TextWob(String value) {
		this._value = value;
	}
	
	/**
	 * Returns the string value.
	 * 
	 * @return the string value
	 */
	public String getValue() {
		return _value;
	}

	/**
	 * @exclude
	 */
	public void _presentationStarted() {
    if (pushAtStartup)
    	pushValue();
	}

	/**
	 * @exclude
	 */
	public String toString() {
		return _value;
	}

	/**
	 * Pushes the text value through the Text Pushed out-port
	 * @exclude
	 */		
	private void pushValue() {
		sendText(_value, 1);
	}
	
	/**
	 * @exclude
	 */
	public void readData(DataInputStream dis) {
		try {
			_value = dis.readUTF();
			pushAtStartup = dis.readBoolean();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

/**
 * 
 */
	public void processInportEvent(Wob arg, int inport) {
		switch (inport) {
		case 1:
			_value = ((TextWob) arg)._value;// Set Value
			break;
		case 2:
			sendText(_value, 1);
			break; // Push Number
		case 3:
			_value = "" + ((wobs.number.player.NumberWob) arg)._value;// Set Value
			if (_value.endsWith(".0"))
				_value = _value.substring(0, _value.length() - 2);
			break;
		case 4:
			String s = ((TextWob) arg)._value; // Append
			if (s.equals("\b"))
				_value = _value.substring(0, Math.max(0, _value.length() - 1));
			else
				_value = _value + s;
			break;
		}
	}
}