/*
 * @(#)SliderImage.java
 *
 * Copyright 2007 Demicron, Inc. All rights reserved.
 *
 * This software is the proprietary information of Demicron, Inc.
 */
package wobs.slider;

import java.awt.*;
import java.io.File;
import javax.swing.ImageIcon;
import javax.swing.JComponent;

public class SliderImage extends JComponent {
	static final long serialVersionUID = -6851891510930237636L;
	
	private Image sliderImg;

	private Image markerImg;

	private int height;

	private int width;

	SliderImage() {
	}

	public void paint(Graphics g) {
		int i = (width - markerImg.getWidth(this)) / 2;
		int j = (height - markerImg.getHeight(this)) / 2;
		int k = (width - sliderImg.getWidth(this)) / 2;
		int l = (height - sliderImg.getHeight(this)) / 2;
		if (sliderImg != null)
			g.drawImage(sliderImg, k, l, this);
		if (markerImg != null)
			g.drawImage(markerImg, i, j, this);
		super.paint(g);
	}

	public Dimension getPreferredSize() {
		return getImageDimension();
	}

	public Dimension getImageDimension() {
		if (sliderImg == null) {
			return new Dimension(0, 0);
		} else {
			height = Math.max(sliderImg.getHeight(this), markerImg.getHeight(this));
			width = Math.max(sliderImg.getWidth(this), markerImg.getWidth(this));
			return new Dimension(width, height);
		}
	}

	public void setSliderImage(File file) {
		try {
			sliderImg = (new ImageIcon(file.toURI().toURL())).getImage();
		} catch (Exception exception) {
		}
	}

	public void setMarkerImage(File file) {
		try {
			markerImg = (new ImageIcon(file.toURI().toURL())).getImage();
		} catch (Exception exception) {
		}
	}

	public Image getSliderImage() {
		return sliderImg;
	}

	public Image getMarkerImage() {
		return markerImg;
	}

}